---
layout: default
title: Our commitment to open source
description: lakeFS is an open source project under the Apache 2.0 license. 
nav_order: 53
has_children: false
redirect_from: ./understand/licensing.html
---

# Our commitment to open source

lakeFS is an open source project under the [Apache 2.0 license](https://www.apache.org/licenses/LICENSE-2.0).
The project was created and is supported by Treeverse, a commercial company, founded by engineers passionate about providing solutions to the evolving world of data engineering.

***Why did we choose to open the source of our core capabilities?***

We believe in bottom up adoption of technologies.
We believe collaborative communities have the power to bring the best solutions to the community.
We believe small organizations should be able to use cutting edge technologies for free, so they can innovate in their domain and compete with well established companies that can afford paying for technology.

As a commercial organization, we intend to use an open core model.

![Open Core Model]({{ site.baseurl }}/assets/img/open_core.png)

***What is our commitment to open source?***

We define lakeFS, our open source project, as the data lake management platform that provides Git-like operations over an object-storage, that can be utilized by any applications accessing the data lake. 
In other words, the following will remain part of lakeFS:

  - The Versioning capabilities
  - ACID Guarantees
  - Git-Like interface for the versioning operations
  - Support for public object store APIs
  - Integration to publicly available applications accessing an object storage
  - Clear CLI, API and GUI interfaces
  
We also commit that lakeFS will be scalable in throughput and performance, and will support multi region architecture.
We are deeply committed to our community of engineers who use and contribute to the project. We are and will continue to be highly responsive and shape lakeFS together to provide the data lake management capabilities we are all looking for.

***What will be included in the commercial layer?***

Well, it will take a while to figure out, and currently everything we do is open source, but in the future, we will provide a commercial offering according to users’ feedback.
For example, SLA based support was already requested by some of our design partners. Apparently some organizations feel comfortable with being early adopters of technology if they have the guarantee that when an issue arises someone is committed contractually to resolve it within a given SLA. If this is your preference, we are here for you.
In addition, in the future, we may choose to provide usability features over the core capabilities, enterprise features revolving around user management and security, and a SaaS offering.  


